<?php
/*
Plugin Name: reCAPTCHA Form
Plugin URI: http://plugins.gattdesign.co.uk/wordpress-plugins/recaptcha-form
Version: 1.0.1
Author: Gatt Design
Author URI: http://plugins.gattdesign.co.uk
Description: This plugin enables you to use a reCAPTCHA contact form on your blog.

 Copyright 2009 Gatt Design  (email : plugins@gattdesign.co.uk)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

// admin sidebar menu option
add_action('admin_menu', 'gatt_design_recaptcha_plugin_menu');

// admin plugin functions
function gatt_design_recaptcha_plugin_menu() {
	add_options_page('reCAPTCHA Form Settings', 'reCAPTCHA Form', 8, __FILE__, 'gatt_design_recaptcha_plugin_settings');
}

function gatt_design_recaptcha_plugin_settings() {
	// form submitted
	if(isset($_POST['recaptcha_admin'])) {	
		$gatt_design_recaptcha_public = get_option('gd_recap_publickey');
		$gatt_design_recaptcha_private = get_option('gd_recap_privatekey');
		$gatt_design_recaptcha_public_checka = false;
		$gatt_design_recaptcha_private_checka = false;

		// public key
		switch($gatt_design_recaptcha_public) {
			case false:
				if(add_option('gd_recap_publickey', 'Public Key Goes Here', '', 'no')) {
					$gatt_design_recaptcha_public_checka = 'no_key';
				} else {
					update_option('gd_recap_publickey', 'Public Key Goes Here');
					$gatt_design_recaptcha_public = get_option('gd_recap_publickey');
					$gatt_design_recaptcha_public_checka = 'no_key';
				}
				
				break;
				
			case true:
				$gatt_design_recaptcha_form_opt_pub = $_POST['gd_recap_publickey'];
				
				if($gatt_design_recaptcha_form_opt_pub == 'Public Key Goes Here') {
					$gatt_design_recaptcha_public_checka = 'no_key';
				} else {
					if(($gatt_design_recaptcha_form_opt_pub == null) || (empty($gatt_design_recaptcha_form_opt_pub))) {
						update_option('gd_recap_publickey', 'Public Key Goes Here');
						$gatt_design_recaptcha_public = get_option('gd_recap_publickey');
						$gatt_design_recaptcha_public_checka = 'no_key';						
					} else {
						update_option('gd_recap_publickey', $gatt_design_recaptcha_form_opt_pub);
						$gatt_design_recaptcha_public = get_option('gd_recap_publickey');
						$gatt_design_recaptcha_public_checka = 'yes_key';
					}
				}
				break;
		}
		
		// private key
		switch($gatt_design_recaptcha_private) {
			case false:
				if(add_option('gd_recap_privatekey', 'Private Key Goes Here', '', 'no')) {
					$gatt_design_recaptcha_private_checka = 'no_key';
				} else {
					update_option('gd_recap_privatekey', 'Private Key Goes Here');
					$gatt_design_recaptcha_private = get_option('gd_recap_privatekey');
					$gatt_design_recaptcha_private_checka = 'no_key';
				}
				
				break;
				
			case true:
				$gatt_design_recaptcha_form_opt_pri = $_POST['gd_recap_privatekey'];
				
				if($gatt_design_recaptcha_form_opt_pri == 'Private Key Goes Here') {
					$gatt_design_recaptcha_private_checka = 'no_key';
				} else {
					if(($gatt_design_recaptcha_form_opt_pri == null) || (empty($gatt_design_recaptcha_form_opt_pri))) {
						update_option('gd_recap_privatekey', 'Private Key Goes Here');
						$gatt_design_recaptcha_private = get_option('gd_recap_privatekey');
						$gatt_design_recaptcha_private_checka = 'no_key';						
					} else {
						update_option('gd_recap_privatekey', $gatt_design_recaptcha_form_opt_pri);
						$gatt_design_recaptcha_private = get_option('gd_recap_privatekey');
						$gatt_design_recaptcha_private_checka = 'yes_key';
					}
				}
				break;
		}
	// form not submitted
	} else {
		$gatt_design_recaptcha_public_checka = false;
		$gatt_design_recaptcha_private_checka = false;
		$gatt_design_recaptcha_public = get_option('gd_recap_publickey');
		$gatt_design_recaptcha_private = get_option('gd_recap_privatekey');

		// public key
		switch($gatt_design_recaptcha_public) {
			case false:
				if(add_option('gd_recap_publickey', 'public key', '', 'no')) {
					add_option('gd_recap_publickey', 'Public Key Goes Here', '', 'no');
					$gatt_design_recaptcha_public_checka = 'no_key';
				} else {
					update_option('gd_recap_publickey', 'Public Key Goes Here');
					$gatt_design_recaptcha_public = get_option('gd_recap_publickey');
					$gatt_design_recaptcha_public_checka = 'no_key';
				}
				
				break;
				
			case true:
				if($gatt_design_recaptcha_public == 'Public Key Goes Here') {
					$gatt_design_recaptcha_public_checka = 'no_key';
				} elseif($gatt_design_recaptcha_public == null) {
					update_option('gd_recap_publickey', 'Public Key Goes Here');
					$gatt_design_recaptcha_public_checka = 'no_key';
				} else {
					$gatt_design_recaptcha_public_checka = 'do_nothing';
				}
				
				break;
		}
		
		// private key
		switch($gatt_design_recaptcha_private) {
			case false:
				if(add_option('gd_recap_privatekey', 'Private Key Goes Here', '', 'no')) {
					$gatt_design_recaptcha_private_checka = 'no_key';
				} else {
					update_option('gd_recap_privatekey', 'Private Key Goes Here');
					$gatt_design_recaptcha_private = get_option('gd_recap_privatekey');
					$gatt_design_recaptcha_private_checka = 'no_key';
				}
				
				break;
				
			case true:
				if($gatt_design_recaptcha_private == 'Private Key Goes Here') {
					$gatt_design_recaptcha_private_checka = 'no_key';
				} elseif($gatt_design_recaptcha_private == null) {
					update_option('gd_recap_privatekey', 'Private Key Goes Here');
					$gatt_design_recaptcha_private_checka = 'no_key';
				} else {
					$gatt_design_recaptcha_private_checka = 'do_nothing';
				}
				
				break;
		}
	}
	
	// display appropriate message
	if(($gatt_design_recaptcha_private_checka == 'no_key') || ($gatt_design_recaptcha_public_checka == 'no_key')){
?>
<div class="error"><p><strong><?php _e('Please populate the required fields.', 'recaptcha_plugin_menu' ); ?></strong></p></div>
<?php	
	} elseif(($gatt_design_recaptcha_private_checka == 'do_nothing') && ($gatt_design_recaptcha_public_checka == 'do_nothing')) {
		// do nothing
	} else {
?>
<div class="updated"><p><strong><?php _e('Settings updated.', 'recaptcha_plugin_menu' ); ?></strong></p></div>
<?php	
	}
?>
<div class="wrap">
	<h2>reCAPTCHA Form</h2>
	<h3>Settings</h3>
	<form method="post" action="<?php echo str_replace( '%7E', '~', $_SERVER['REQUEST_URI']); ?>">
		<?php wp_nonce_field('update-options'); ?>
		
		<table class="form-table">
			<tr valign="top">
				<th scope="row">reCAPTCHA public key</th>
				<td>
					<input type="text" name="gd_recap_publickey" value="<?php echo $gatt_design_recaptcha_public; ?>" />
				</td>
			</tr>
			<tr valign="top">
				<th scope="row">reCAPTCHA private key</th>
				<td>
					<input type="text" name="gd_recap_privatekey" value="<?php echo $gatt_design_recaptcha_private; ?>" />
				</td>
			</tr>
			<tr valign="top">
				<td colspan="2">
					<p>NOTE: If you haven't already got reCAPTCHA private and public keys, you can get them by visiting the <a href="http://recaptcha.net/whyrecaptcha.html">reCAPTCHA website</a>.</p>
				</td>			
			</tr>
		</table>
		
		<input type="hidden" name="action" value="update" />
		<input type="hidden" name="page_options" value="gd_recap_privatekey" />
		<input type="hidden" name="page_options" value="gd_recap_publickey" />
		<p class="submit"><input type="submit" class="button-primary" name="recaptcha_admin" value="<?php _e('Save Changes') ?>" /></p>
	</form>
</div>
<?php
}

// shortcode and message handling functions
function gatt_design_recaptcha_short_code() {
	$gatt_design_recaptcha_privkey_checka = get_option('gd_recap_privatekey');
	$gatt_design_recaptcha_pubkey_checka = get_option('gd_recap_publickey');
	
	// one or both keys are invalid	
	if(($gatt_design_recaptcha_privkey_checka == 'Private Key Goes Here') || ($gatt_design_recaptcha_pubkey_checka == 'Public Key Goes Here')) {
		$gatt_design_recaptcha_form_code = '';
	// one or both keys are empty	
	} elseif(($gatt_design_recaptcha_privkey_checka == null) || ($gatt_design_recaptcha_pubkey_checka == null)) {
		$gatt_design_recaptcha_form_code = '';
	// both keys are valid
	} else {
		// message has been submitted
		if(isset($_POST['recaptcha_client'])) {
			// include reCAPTCHA library (only if it hasn't been declared elsewhere)
			if(!is_callable(recaptcha_check_answer)) require_once('recaptchalib.php');
			
			// check reCAPTCHA response
			$gatt_design_recaptcha_response = recaptcha_check_answer ($gatt_design_recaptcha_privkey_checka, $_SERVER["REMOTE_ADDR"], $_POST["recaptcha_challenge_field"], $_POST["recaptcha_response_field"]);
			
			// recaptcha challenge failed, show error message and contact form
			if (!$gatt_design_recaptcha_response->is_valid) {
				$gatt_design_recaptcha_form_code = '<!-- start of recaptcha form -->' . "\n";
				$gatt_design_recaptcha_form_code .= '<p style="text-align: left; font-weight: bold; background-color: white; color: red; border: 1px solid black; padding: 10px;">Invalid reCAPTCHA phrase - please try again.</p>' . "\n";
				$gatt_design_recaptcha_form_code .= '<br />' . "\n";
				$gatt_design_recaptcha_form_code .= '<form method="post" action="' . str_replace( '%7E', '~', $_SERVER['REQUEST_URI']) . '">' . "\n";
				$gatt_design_recaptcha_form_code .= '<fieldset style="border: 0px; margin: 0px; padding: 0px;">' . "\n";
				$gatt_design_recaptcha_form_code .= '<p style="text-align: left;">Your Name:<br /><label for="recaptcha_form_name"><input type="text" name="recaptcha_form_name" value="" style="width: 200px;" /></label></p>' . "\n";
				$gatt_design_recaptcha_form_code .= '<p style="text-align: left;">Your Email Address:<br /><label for="recaptcha_form_email"><input type="text" name="recaptcha_form_email" value="" style="width: 200px;" /></label></p>' . "\n";
				$gatt_design_recaptcha_form_code .= '<p style="text-align: left;">Your Message:<br /><label for="recaptcha_form_message"><textarea name="recaptcha_form_message" value="" rows="10" cols="20" style="width: 350px;"></textarea></label></p>' . "\n";
				$gatt_design_recaptcha_form_code .= '<script type="text/javascript" src="http://api.recaptcha.net/challenge?k=' . $gatt_design_recaptcha_pubkey_checka . '"></script>' . "\n";
				$gatt_design_recaptcha_form_code .= '<noscript>' . "\n";
				$gatt_design_recaptcha_form_code .= '<iframe src="http://api.recaptcha.net/noscript?k=' . $gatt_design_recaptcha_pubkey_checka . '" height="300" width="500" frameborder="0"></iframe>' . "\n";
				$gatt_design_recaptcha_form_code .= '<br />' . "\n";
				$gatt_design_recaptcha_form_code .= '<textarea name="recaptcha_challenge_field" rows="3" cols="40"></textarea>' . "\n";
				$gatt_design_recaptcha_form_code .= '<input type="hidden" name="recaptcha_response_field" value="manual_challenge" />' . "\n";
				$gatt_design_recaptcha_form_code .= '</noscript>' . "\n";
				$gatt_design_recaptcha_form_code .= '<br />' . "\n";
				$gatt_design_recaptcha_form_code .= '<p style="text-align: left;"><input type="submit" name="recaptcha_client" value="   Submit Message   " /></p>' . "\n";
				$gatt_design_recaptcha_form_code .= '</fieldset>' . "\n";
				$gatt_design_recaptcha_form_code .= '</form>' . "\n";
				$gatt_design_recaptcha_form_code .= '<!-- end of recaptcha form -->' . "\n";
			// recaptcha challenge passed
			} else {
				$gatt_design_recaptcha_form_name_field = $_POST['recaptcha_form_name'];
				$gatt_design_recaptcha_form_email_field = $_POST['recaptcha_form_email'];
				$gatt_design_recaptcha_form_message_field = $_POST['recaptcha_form_message'];
				
				// some fields are empty, show error message and contact form
				if(($gatt_design_recaptcha_form_name_field == null) || ($gatt_design_recaptcha_form_email_field == null) || ($gatt_design_recaptcha_form_message_field == null)) {
					$gatt_design_recaptcha_form_code = '<!-- start of recaptcha form -->' . "\n";
					$gatt_design_recaptcha_form_code .= '<p style="text-align: left; font-weight: bold; background-color: white; color: red; border: 1px solid black; padding: 10px;">Please fill in ALL fields.</p>' . "\n";
					$gatt_design_recaptcha_form_code .= '<br />' . "\n";
					$gatt_design_recaptcha_form_code .= '<form method="post" action="' . str_replace( '%7E', '~', $_SERVER['REQUEST_URI']) . '">' . "\n";
					$gatt_design_recaptcha_form_code .= '<fieldset style="border: 0px; margin: 0px; padding: 0px;">' . "\n";
					$gatt_design_recaptcha_form_code .= '<p style="text-align: left;">Your Name:<br /><label for="recaptcha_form_name"><input type="text" name="recaptcha_form_name" value="" style="width: 200px;" /></label></p>' . "\n";
					$gatt_design_recaptcha_form_code .= '<p style="text-align: left;">Your Email Address:<br /><label for="recaptcha_form_email"><input type="text" name="recaptcha_form_email" value="" style="width: 200px;" /></label></p>' . "\n";
					$gatt_design_recaptcha_form_code .= '<p style="text-align: left;">Your Message:<br /><label for="recaptcha_form_message"><textarea name="recaptcha_form_message" value="" rows="10" cols="20" style="width: 350px;"></textarea></label></p>' . "\n";
					$gatt_design_recaptcha_form_code .= '<script type="text/javascript" src="http://api.recaptcha.net/challenge?k=' . $gatt_design_recaptcha_pubkey_checka . '"></script>' . "\n";
					$gatt_design_recaptcha_form_code .= '<noscript>' . "\n";
					$gatt_design_recaptcha_form_code .= '<iframe src="http://api.recaptcha.net/noscript?k=' . $gatt_design_recaptcha_pubkey_checka . '" height="300" width="500" frameborder="0"></iframe>' . "\n";
					$gatt_design_recaptcha_form_code .= '<br />' . "\n";
					$gatt_design_recaptcha_form_code .= '<textarea name="recaptcha_challenge_field" rows="3" cols="40"></textarea>' . "\n";
					$gatt_design_recaptcha_form_code .= '<input type="hidden" name="recaptcha_response_field" value="manual_challenge" />' . "\n";
					$gatt_design_recaptcha_form_code .= '</noscript>' . "\n";
					$gatt_design_recaptcha_form_code .= '<br />' . "\n";
					$gatt_design_recaptcha_form_code .= '<p style="text-align: left;"><input type="submit" name="recaptcha_client" value="   Submit Message   " /></p>' . "\n";
					$gatt_design_recaptcha_form_code .= '</fieldset>' . "\n";
					$gatt_design_recaptcha_form_code .= '</form>' . "\n";
					$gatt_design_recaptcha_form_code .= '<!-- end of recaptcha form -->' . "\n";
				// all fields have input, send email and display confirmation message
				} else {
					// construct mail 
					$gatt_design_recaptcha_email_sender = 'From: ' . $gatt_design_recaptcha_form_name_field . ' <' . $gatt_design_recaptcha_form_email_field . '>';
					$gatt_design_recaptcha_email_receiver = get_option('blogname') . ' <' . get_option('admin_email') . '>';
					$gatt_design_recaptcha_email_body = 'You have received a message from ' . get_option('blogname') . '.  Message details are as follows:' . "\n\n";
					$gatt_design_recaptcha_email_body .= 'Date and Time: ' . date("l jS F Y H:i:s") . "\n\n";
					$gatt_design_recaptcha_email_body .= 'IP address: ' . $_SERVER['REMOTE_ADDR'] . ' (' . gethostbyaddr($_SERVER['REMOTE_ADDR']) . ')' . "\n\n";
					$gatt_design_recaptcha_email_body .= 'Message: ' . $gatt_design_recaptcha_form_message_field;
					
					//mail sent
					if(wp_mail($gatt_design_recaptcha_email_receiver, 'New Message From ' . get_option('blogname'), $gatt_design_recaptcha_email_body, $gatt_design_recaptcha_email_sender)) {
						$gatt_design_recaptcha_form_code = '<!-- start of recaptcha form -->' . "\n";
						$gatt_design_recaptcha_form_code .= '<p style="text-align: left; font-weight: bold; background-color: white; color: green; border: 1px solid black; padding: 10px;">Your message has been sent.</p>' . "\n";
						$gatt_design_recaptcha_form_code .= '<!-- end of recaptcha form -->' . "\n";
					// problem sending mail
					} else {
						$gatt_design_recaptcha_form_code = '<!-- start of recaptcha form -->' . "\n";
						$gatt_design_recaptcha_form_code .= '<p style="text-align: left; font-weight: bold; background-color: white; color: red; border: 1px solid black; padding: 10px;">Your message could not be sent at this time.</p>' . "\n";
						$gatt_design_recaptcha_form_code .= '<!-- end of recaptcha form -->' . "\n";
					}
					$gatt_design_recaptcha_form_code = '<!-- start of recaptcha form -->' . "\n";
					$gatt_design_recaptcha_form_code .= '<p style="text-align: left; font-weight: bold; background-color: white; color: green; border: 1px solid black; padding: 10px;">Your message has been sent.</p>' . "\n";
					$gatt_design_recaptcha_form_code .= '<!-- end of recaptcha form -->' . "\n";
				}
			}
		// message hasn't been submitted, display contact form
		} else {
			$gatt_design_recaptcha_form_code = '<!-- start of recaptcha form -->' . "\n";
			$gatt_design_recaptcha_form_code .= '<form method="post" action="' . str_replace( '%7E', '~', $_SERVER['REQUEST_URI']) . '">' . "\n";
			$gatt_design_recaptcha_form_code .= '<fieldset style="border: 0px; margin: 0px; padding: 0px;">' . "\n";
			$gatt_design_recaptcha_form_code .= '<p style="text-align: left;">Your Name:<br /><label for="recaptcha_form_name"><input type="text" name="recaptcha_form_name" value="" style="width: 200px;" /></label></p>' . "\n";
			$gatt_design_recaptcha_form_code .= '<p style="text-align: left;">Your Email Address:<br /><label for="recaptcha_form_email"><input type="text" name="recaptcha_form_email" value="" style="width: 200px;" /></label></p>' . "\n";
			$gatt_design_recaptcha_form_code .= '<p style="text-align: left;">Your Message:<br /><label for="recaptcha_form_message"><textarea name="recaptcha_form_message" value="" rows="10" cols="20" style="width: 350px;"></textarea></label></p>' . "\n";
			$gatt_design_recaptcha_form_code .= '<script type="text/javascript" src="http://api.recaptcha.net/challenge?k=' . $gatt_design_recaptcha_pubkey_checka . '"></script>' . "\n";
			$gatt_design_recaptcha_form_code .= '<noscript>' . "\n";
			$gatt_design_recaptcha_form_code .= '<iframe src="http://api.recaptcha.net/noscript?k=' . $gatt_design_recaptcha_pubkey_checka . '" height="300" width="500" frameborder="0"></iframe>' . "\n";
			$gatt_design_recaptcha_form_code .= '<br />' . "\n";
			$gatt_design_recaptcha_form_code .= '<textarea name="recaptcha_challenge_field" rows="3" cols="40"></textarea>' . "\n";
			$gatt_design_recaptcha_form_code .= '<input type="hidden" name="recaptcha_response_field" value="manual_challenge" />' . "\n";
			$gatt_design_recaptcha_form_code .= '</noscript>' . "\n";
			$gatt_design_recaptcha_form_code .= '<br />' . "\n";
			$gatt_design_recaptcha_form_code .= '<p style="text-align: left;"><input type="submit" name="recaptcha_client" value="   Submit Message   " /></p>' . "\n";
			$gatt_design_recaptcha_form_code .= '</fieldset>' . "\n";
			$gatt_design_recaptcha_form_code .= '</form>' . "\n";
			$gatt_design_recaptcha_form_code .= '<!-- end of recaptcha form -->' . "\n";
		}
	}
	
	return $gatt_design_recaptcha_form_code;
}

// create the shortcode
add_shortcode('recaptcha_form', 'gatt_design_recaptcha_short_code');

?>